/****************************************************************************
*
* ܹϵͳ  9Eye Keyword Scan System Copyright (c) 2000-2017
*     Dr. Kevin Zhang (Hua-Ping Zhang)
*
*     All rights reserved.
*
* This file is the confidential and proprietary property of
* Kevin Zhang and the possession or use of this file requires
* a written license from the author.
* Filename:
* Abstract:
*          KeyScan.h: definition of the system API
* Author:   Kevin Zhang
*          Email: pipy_zhang@msn.com kevinzhang@bit.edu.cn
*			Weibo: http://weibo.com/drkevinzhang
*			Homepage: http://9Eye.nlpir.org
* Date:     2013-12-19
*
* Notes:һùؼʣɨ಻ʵı壬緱ʽмӸ
*
****************************************************************************/
#ifndef _H_KS_DLL
#define _H_KS_DLL

#ifdef OS_LINUX
	#define KEYSCANAPI_API  extern "C"
#else
	#ifdef KEYSCANAPI_EXPORTS
		#define KEYSCANAPI_API extern "C" __declspec(dllexport)
	#else
		#define KEYSCANAPI_API extern "C" __declspec(dllimport)
	#endif
#endif

#ifdef KEY_SCAN_INTERNAL
#define KEYSCANAPI_API 
#endif

#define GBK_CODE 0//Ĭ֧GBK
#define UTF8_CODE GBK_CODE+1//UTF8
#define BIG5_CODE GBK_CODE+2//BIG5
#define GBK_FANTI_CODE GBK_CODE+3//GBK룬
#define UTF8_FANTI_CODE GBK_CODE+4//UTF8
#define ENCODING_UTF8_FJ ENCODING_GBK+5//UTF8תԶתɨ˹ܽʹ
#define KS_HANDLE int

#define SCAN_MODE_NORMAL 0//ɨģʽ
#define SCAN_MODE_SHAPE 1//αɨģʽ
#define SCAN_MODE_PINYIN 2//ƴɨģʽ
#define SCAN_MODE_CHECK 3//Уɨģʽ

/*********************************************************************
 *
 *  Func Name  : Init
 *
 *  Description: Init KS ϵͳʼ
 *               The function must be invoked before any operation listed as following
 *
 *  Parameters : const char * sInitDirPath:  Path where Data directory stored. ݴʵ洢·
 *				 the default value is NULL, it indicates the initial directory is current working directory path
 *				 encode: encoding code;
 *				 sLicenseCode: license code for unlimited usage. common user ignore it
 *  Returns    : success or fail ; ԭ¼ͨKS_GetLastErrorMsg
 *  Author     : Kevin Zhang  
 *  History    : 
 *              1.create 2013-6-8
 *********************************************************************/
KEYSCANAPI_API int KS_Init(const char *sInitDirPath = "", int encode = GBK_CODE, const char*sLicenceCode = 0,const char *sDelimiter=",");


/*************************************************************************
*
*  Func Name  : KS_Exit
*
*  Description: Exist KS and free related buffer ˳ͷԴ
*               Exit the program and free memory
*				 The function must be invoked while you needn't any lexical anlysis
*
*  Parameters : None
*
*  Returns    : success or fail
*  Author     : Kevin Zhang
*  History    :
*              1.create 2002-8-6
*********************************************************************/
KEYSCANAPI_API void KS_Exit();

/*********************************************************************
*
*  Func Name  : KS_NewInstance
*
*  Description: New a  KeyScan Instance
*               The function must be invoked before mulitiple keyword scan filter
*
*  Parameters : 
*  Returns    : KS_HANDLE: KeyScan Handle if success; otherwise return -1;
*  Author     : Kevin Zhang
*  History    :
*              1.create 2016-11-15
*********************************************************************/
KEYSCANAPI_API KS_HANDLE KS_NewInstance();

/*********************************************************************
*
*  Func Name  : KS_DeleteInstance
*
*  Description: Delete a  KeyScan Instance with handle
*               The function must be invoked before release a specific classifier
*
*  Parameters : DC_HANDLE , KeyScan Handle
*  Returns    : 
*  Author     : Kevin Zhang
*  History    :
*              1.create 2015-9-22
*********************************************************************/
KEYSCANAPI_API int KS_DeleteInstance(KS_HANDLE handle);

/*********************************************************************
 *
 *  Func Name  : ImportUserDict
 *
 *  Description: Import User-defined dictionary ûʵ
 *  Parameters : 
 *				sFilename:Text filename for user dictionary 
 *				bool bOverwrite: trueϵͳѾеĴʱ򽫲׷ӵķʽ׷Ӳʱ
 *				KS_HANDLE handle handle of KeyScanner
 *
 *  Returns    : The  number of  lexical entry imported successfully
 *               ɹĴʵ
 *  Author     : Kevin Zhang
 *  History    : 
 *              1.create 2014-8-3
 *  ıļÿеĸʽΪ  Ȩ (ע⣬ඨ255)
 *        磺 AVӰ ɫ 2
 *				 ϲ  8 1
 * ӹ ֧Ǵ ;ʾϵ+ʾϵ-ʾ
 * ʽ£{key11;key12;key13;...;key1N}+{key21;key22;key23;...;key2N}+...+{keyM1;keyM2;keyM3;...;keyMN}  -{}
//  ʾ {й;л;л񹲺͹;й;й}+{ΰ;;ȷ}-{л;}   5
//   ʾǣ ıа {й;л;л񹲺͹;й;й}еһ֣ͬʱ {ΰ;;ȷ}еһܳ{л;}κһ
 *********************************************************************/
KEYSCANAPI_API int KS_ImportUserDict(const char *sFilename,bool bPinyinAbbrevNeeded=false, bool bOverwrite = false, KS_HANDLE handle=0);

/*********************************************************************
*
*  Func Name  : DeleteUserDict
*
*  Description: Delete User-defined dictionary ɾûʵ
*  Parameters :
*				sFilename:Text filename for user dictionary
*				KS_HANDLE handle handle of KeyScanner
*  Returns    : The  number of  lexical entry deleted successfully
*               ɹɾĴʵ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2014-8-3
*  ıļÿеĸʽΪ
*        磺 AVӰ
*				 ϰƽ
*********************************************************************/
KEYSCANAPI_API int KS_DeleteUserDict(const char *sFilename, KS_HANDLE handle = 0);

/*********************************************************************
 *
 *  Func Name  : KS_Scan
 *
 *  Description: ɨı
 *  Parameters : sContent:ı
 *				KS_HANDLE handle handle of KeyScanner
 *  Returns    : const char*: 漰ȨأȨ
 *				 磺 ɫ/10#/1#
 *				 ""ʾɨн
 *  Author     : Kevin Zhang
 *  History    : 
 *              1.create 2014-8-3
 *  ʽΪ η/2#FLG/1#쵼/1#
*********************************************************************/
KEYSCANAPI_API const char* KS_Scan(const char*sContent, KS_HANDLE handle = 0);

/*********************************************************************
 *
 *  Func Name  : KS_ScanDetail
 *
 *  Description: ɨı
 *  Parameters : sContent:ı
 *				KS_HANDLE handle handle of KeyScanner
 *  Returns    : ؾ漰ݣ
 *  Author     : Kevin Zhang
 *  History    : 
 *              1.create 2014-8-3
// صĸʽ£
// ֵذɨݣɨϸ:
//
//		*<class name="η" weight=1>ϰ*-</class>*(ɢؔͯӣĲˬ
//		<class name="FLG" weight=1>*݆</class>ã
*********************************************************************/
KEYSCANAPI_API const char* KS_ScanDetail(const char*sContent, int nScanMode=SCAN_MODE_NORMAL, KS_HANDLE handle = 0);

/*********************************************************************
*
*  Func Name  : KS_ScanFile
*
*  Description: ɨıļ
*  Parameters : sFilename:ıļ
*				KS_HANDLE handle handle of KeyScanner
*  Returns    : const char*: 漰ȨأȨ
*				 磺 ɫ/10##/1##
*				 ""ʾɨн
*  Author     : Kevin Zhang
*  History    :
*              1.create 2014-8-3
*  ıļĸʽΪ
*        磺 AVӰ ɫ
*********************************************************************/
KEYSCANAPI_API const char* KS_ScanFile(const char	*sFilename, KS_HANDLE handle = 0);

/*********************************************************************
*
*  Func Name  : KS_ScanFileDetail
*
*  Description: ɨıļ
*  Parameters : sFilename:ıļ
*				KS_HANDLE handle handle of KeyScanner
*  Returns    : ؾ漰ݣ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2014-8-3
// صĸʽ£
// ֵذɨݣɨϸ:
//		   *<class name="η" weight=1>ϰ*-</class>*(ɢؔͯӣĲˬ
//		<class name="FLG" weight=1>*݆</class>ã
*********************************************************************/
KEYSCANAPI_API const char* KS_ScanFileDetail(const char	*sFilename,KS_HANDLE handle = 0);

/*********************************************************************
*
*  Func Name  : KS_ScanLine
*
*  Description: ɨıļ
*  Parameters : sFilename:ıļ
*			    sResultFilename: Ľļ
*				KS_HANDLE handle handle of KeyScanner
*				int bEncript:0 ܣ1
*  Returns    : 漰
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-1-12
// صĸʽ£
// ֵذɨкݣɨϸ:
//		   *<class name="η" weight=1>ϰ*-</class>*(ɢؔͯӣĲˬ
//		<class name="FLG" weight=1>*݆</class>ã
*********************************************************************/
KEYSCANAPI_API int KS_ScanLine(const char	*sFilename, const char	*sResultFilename, KS_HANDLE handle = 0, int bEncript = false, int nScanMode = SCAN_MODE_NORMAL);
/*********************************************************************
*
*  Func Name  : KS_ScanStat
*
*  Description: ɨͳƱ棬ڽһķ˲
*  Parameters : sResultFile: ļļ
*			    
*				KS_HANDLE handle handle of KeyScanner
*  Returns    : ɹɨ赽ļ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-1-12
// صĸʽ£
*********************************************************************/
KEYSCANAPI_API int KS_ScanStat(const char *sResultFile, KS_HANDLE handle = 0);

/*********************************************************************
*
*  Func Name  : KS_ScanDir
*
*  Description: ߳ɨ谴ɨıļ
*  Parameters : sInputDirPath:ļ·
*               sResultPath: ļ·
*			    nThreadCount: ߳Ĭ10
*				int bEncript:0 ܣ1
*  Returns    : ɹɨ赽ļ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-1-12
// صĸʽ£
*********************************************************************/
KEYSCANAPI_API int KS_ScanDir(const char *sInputDirPath,const char *sResultPath,int nThreadCount=10,int bEncript=false, int scan_mode=0);


/*********************************************************************
*
*  Func Name  : KS_StatResultFilter
*
*  Description: ɨͳƽй˷
*  Parameters : sFilename:Ľļ
*				fThreshold÷ֵֵ
*  Returns    : ɹɨ赽ļ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-4-24
*********************************************************************/
KEYSCANAPI_API int KS_StatResultFilter(const char *sInputFilename, const char *sResultFilename, float fThreshold = 5.0);
/*********************************************************************
*
*  Func Name  : KS_ScanResultFilter
*
*  Description: ɨϸļй˷
*  Parameters : sFilename:Ľļ
*				fThreshold÷ֵֵ
*  Returns    : ɹɨ赽ļ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-4-24
*********************************************************************/
KEYSCANAPI_API int KS_ScanResultFilter(const char *sInputFilename, const char *sResultFilename, float fThreshold =9.0);

/*********************************************************************
*
*  Func Name  : KS_Dencript
*
*  Description: ߳תɨ
*  Parameters : sInputDirPath:ļ·
*               sResultPath: ļ·
*			    nThreadCount: ߳Ĭ10
*				int bEncript:0 ܣ1
*  Returns    : ɹɨ赽ļ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2017-1-12
// صĸʽ£
*********************************************************************/
KEYSCANAPI_API int KS_Decrypt(const char *sInputDirPath, const char *sResultPath);

/*********************************************************************
 *
 *  Func Name  : KS_GetLastErrorMsg
 *
 *  Description: Ϣ
 *				 The function must be invoked while you needn't any lexical anlysis
 *
 *  Parameters : Ϣ
 *
 *  Returns    : success or fail
 *  Author     : Kevin Zhang  
 *  History    : 
 *              1.create 2002-8-6
 *********************************************************************/
KEYSCANAPI_API const char* KS_GetLastErrorMsg();

/*********************************************************************
*
*  Func Name  : KS_ExportDict
*
*  Description: ExportDict dictionary ѾĲʴʵ
*				Ϊ֪ʶȨùܽڹԱڲʹ
*  Parameters :
*				sFilename:Text filename for user dictionary
*				KS_HANDLE handle handle of KeyScanner
*  Returns    : The  number of  lexical entry imported successfully
*               ɹĴʵ
*  Author     : Kevin Zhang
*  History    :
*              1.create 2014-8-3
*  ıļĸʽΪ  Ȩ (ע⣬ඨ255)
*        磺 AVӰ ɫ 2
*				 ϲ  8 1
*********************************************************************/
KEYSCANAPI_API int KS_ExportDict(const char *sFilename, KS_HANDLE handle = 0);
#endif //_H_KS_DLL

